浏览代码

Merge branch 'master' of github.com:robbyrussell/oh-my-zsh

Robby Russell 13 年之前
父节点
当前提交
8a102b941f

+ 1 - 0
.gitignore

@@ -5,3 +5,4 @@ custom/*
 !custom/example
 !custom/example
 !custom/example.zsh
 !custom/example.zsh
 cache
 cache
+*.swp

+ 3 - 0
lib/edit-command-line.zsh

@@ -0,0 +1,3 @@
+autoload -U edit-command-line
+zle -N edit-command-line
+bindkey '\C-x\C-e' edit-command-line

+ 68 - 0
plugins/archlinux/archlinux.plugin.zsh

@@ -0,0 +1,68 @@
+# Archlinux zsh aliases and functions for zsh
+
+# Aliases ###################################################################
+
+# Look for yaourt, and add some useful functions if we have it.
+if [[ -x `which yaourt` ]]; then
+  upgrade () {
+    yaourt -Syu -C
+  }
+  # Pacman - https://wiki.archlinux.org/index.php/Pacman_Tips
+  alias yaupg='sudo yaourt -Syu'        # Synchronize with repositories before upgrading packages that are out of date on the local system.
+  alias yain='sudo yaourt -S'           # Install specific package(s) from the repositories
+  alias yains='sudo yaourt -U'          # Install specific package not from the repositories but from a file 
+  alias yare='sudo yaourt -R'           # Remove the specified package(s), retaining its configuration(s) and required dependencies
+  alias yarem='sudo yaourt -Rns'        # Remove the specified package(s), its configuration(s) and unneeded dependencies
+  alias yarep='yaourt -Si'              # Display information about a given package in the repositories
+  alias yareps='yaourt -Ss'             # Search for package(s) in the repositories
+  alias yaloc='yaourt -Qi'              # Display information about a given package in the local database
+  alias yalocs='yaourt -Qs'             # Search for package(s) in the local database
+  # Additional yaourt alias examples
+  alias yaupd='sudo yaourt -Sy && sudo abs'     # Update and refresh the local package and ABS databases against repositories
+  alias yainsd='sudo yaourt -S --asdeps'        # Install given package(s) as dependencies of another package
+  alias yamir='sudo yaourt -Syy'                # Force refresh of all package lists after updating /etc/pacman.d/mirrorlist
+else
+ upgrade() {
+   sudo pacman -Syu
+ }
+fi
+
+# Pacman - https://wiki.archlinux.org/index.php/Pacman_Tips
+alias pacupg='sudo pacman -Syu'        # Synchronize with repositories before upgrading packages that are out of date on the local system.
+alias pacin='sudo pacman -S'           # Install specific package(s) from the repositories
+alias pacins='sudo pacman -U'          # Install specific package not from the repositories but from a file 
+alias pacre='sudo pacman -R'           # Remove the specified package(s), retaining its configuration(s) and required dependencies
+alias pacrem='sudo pacman -Rns'        # Remove the specified package(s), its configuration(s) and unneeded dependencies
+alias pacrep='pacman -Si'              # Display information about a given package in the repositories
+alias pacreps='pacman -Ss'             # Search for package(s) in the repositories
+alias pacloc='pacman -Qi'              # Display information about a given package in the local database
+alias paclocs='pacman -Qs'             # Search for package(s) in the local database
+# Additional pacman alias examples
+alias pacupd='sudo pacman -Sy && sudo abs'     # Update and refresh the local package and ABS databases against repositories
+alias pacinsd='sudo pacman -S --asdeps'        # Install given package(s) as dependencies of another package
+alias pacmir='sudo pacman -Syy'                # Force refresh of all package lists after updating /etc/pacman.d/mirrorlist
+
+# https://bbs.archlinux.org/viewtopic.php?id=93683
+paclist() {
+  sudo pacman -Qei $(pacman -Qu|cut -d" " -f 1)|awk ' BEGIN {FS=":"}/^Name/{printf("\033[1;36m%s\033[1;37m", $2)}/^Description/{print $2}'
+}
+
+alias paclsorphans='sudo pacman -Qdt'
+alias pacrmorphans='sudo pacman -Rs $(pacman -Qtdq)'
+
+pacdisowned() {
+  tmp=${TMPDIR-/tmp}/pacman-disowned-$UID-$$
+  db=$tmp/db
+  fs=$tmp/fs
+
+  mkdir "$tmp"
+  trap  'rm -rf "$tmp"' EXIT
+
+  pacman -Qlq | sort -u > "$db"
+
+  find /bin /etc /lib /sbin /usr \
+      ! -name lost+found \
+        \( -type d -printf '%p/\n' -o -print \) | sort > "$fs"
+
+  comm -23 "$fs" "$db"
+}

+ 33 - 0
plugins/bundler/bundler.plugin.zsh

@@ -1,3 +1,36 @@
 alias be="bundle exec"
 alias be="bundle exec"
 alias bi="bundle install"
 alias bi="bundle install"
+alias bl="bundle list"
 alias bu="bundle update"
 alias bu="bundle update"
+
+# The following is based on https://github.com/gma/bundler-exec
+
+bundled_commands=(cap capify cucumber heroku rackup rails rake rspec ruby shotgun spec spork thin unicorn unicorn_rails)
+
+## Functions
+
+_bundler-installed() {
+  which bundle > /dev/null 2>&1
+}
+
+_within-bundled-project() {
+  local check_dir=$PWD
+  while [ "$(dirname $check_dir)" != "/" ]; do
+    [ -f "$check_dir/Gemfile" ] && return
+    check_dir="$(dirname $check_dir)"
+  done
+  false
+}
+
+_run-with-bundler() {
+  if _bundler-installed && _within-bundled-project; then
+    bundle exec $@
+  else
+    $@
+  fi
+}
+
+## Main program
+for cmd in $bundled_commands; do
+  alias $cmd="_run-with-bundler $cmd"
+done

+ 32 - 0
plugins/cake/cake.plugin.zsh

@@ -0,0 +1,32 @@
+# Set this to 1 if you want to cache the tasks
+cache_task_list=1
+
+# Cache filename
+cache_file='.cake_task_cache'
+
+_cake_does_target_list_need_generating () {
+
+	if [ $cache_task_list -eq 0 ]; then
+		return 1;
+	fi
+
+	if [ ! -f $cache_file ]; then return 0;
+	else
+		accurate=$(stat -f%m $cache_file)
+		changed=$(stat -f%m Cakefile)
+		return $(expr $accurate '>=' $changed)
+	fi
+}
+
+_cake () {
+	if [ -f Cakefile ]; then
+		if _cake_does_target_list_need_generating; then
+			cake | sed -e "s/cake \([^ ]*\) .*/\1/" | grep -v '^$' > $cache_file
+			compadd `cat $cache_file`
+		else
+			compadd `cake | sed -e "s/cake \([^ ]*\) .*/\1/" | grep -v '^$'`
+		fi
+	fi
+}
+
+compdef _cake cake

+ 2 - 0
plugins/cloudapp/cloudapp.plugin.zsh

@@ -0,0 +1,2 @@
+#!/bin/zsh
+alias cloudapp=$ZSH/plugins/cloudapp/cloudapp.rb

+ 60 - 0
plugins/cloudapp/cloudapp.rb

@@ -0,0 +1,60 @@
+#!/usr/bin/env ruby
+#
+# cloudapp
+# Zach Holman / @holman
+#
+# Uploads a file from the command line to CloudApp, drops it into your 
+# clipboard (on a Mac, at least).
+#
+# Example:
+#
+#   cloudapp drunk-blake.png
+#
+# This requires Aaron Russell's cloudapp_api gem:
+#
+#   gem install cloudapp_api
+#
+# Requires you set your CloudApp credentials in ~/.cloudapp as a simple file of:
+#
+#   email
+#   password
+
+require 'rubygems'
+begin
+  require 'cloudapp_api'
+rescue LoadError
+  puts "You need to install cloudapp_api: gem install cloudapp_api"
+  exit!(1)
+end
+
+config_file = "#{ENV['HOME']}/.cloudapp"
+unless File.exist?(config_file)
+  puts "You need to type your email and password (one per line) into "+
+       "`~/.cloudapp`"
+  exit!(1)
+end
+
+email,password = File.read(config_file).split("\n")
+
+class HTTParty::Response
+  # Apparently HTTPOK.ok? IS NOT OKAY WTFFFFFFFFFFUUUUUUUUUUUUUU
+  # LETS MONKEY PATCH IT I FEEL OKAY ABOUT IT
+  def ok? ; true end
+end
+
+if ARGV[0].nil?
+   puts "You need to specify a file to upload."
+   exit!(1)
+end
+
+CloudApp.authenticate(email,password)
+url = CloudApp::Item.create(:upload, {:file => ARGV[0]}).url
+
+# Say it for good measure.
+puts "Uploaded to #{url}."
+
+# Get the embed link.
+url = "#{url}/#{ARGV[0].split('/').last}"
+
+# Copy it to your (Mac's) clipboard.
+`echo '#{url}' | tr -d "\n" | pbcopy`

+ 222 - 0
plugins/django/django.plugin.zsh

@@ -0,0 +1,222 @@
+#compdef manage.py
+
+typeset -ga nul_args
+nul_args=(
+  '--settings=-[the Python path to a settings module.]:file:_files'
+  '--pythonpath=-[a directory to add to the Python path.]::directory:_directories'
+  '--traceback[print traceback on exception.]'
+  "--version[show program's version number and exit.]"
+  {-h,--help}'[show this help message and exit.]'
+)
+
+_managepy-adminindex(){
+  _arguments -s : \
+    $nul_args \
+    '*::directory:_directories' && ret=0
+}
+
+_managepy-createcachetable(){
+  _arguments -s : \
+    $nul_args && ret=0
+}
+
+_managepy-dbshell(){
+  _arguments -s : \
+    $nul_args && ret=0
+}
+
+_managepy-diffsettings(){
+  _arguments -s : \
+    $nul_args && ret=0
+}
+
+_managepy-dumpdata(){
+  _arguments -s : \
+    '--format=-[specifies the output serialization format for fixtures.]:format:(json yaml xml)' \
+    '--indent=-[specifies the indent level to use when pretty-printing output.]:' \
+    $nul_args \
+    '*::appname:_applist' && ret=0
+}
+
+_managepy-flush(){
+  _arguments -s : \
+    '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+    '--noinput[tells Django to NOT prompt the user for input of any kind.]' \
+    $nul_args && ret=0
+}
+
+_managepy-help(){
+  _arguments -s : \
+    '*:command:_managepy_cmds' \
+    $nul_args && ret=0
+}
+
+_managepy_cmds(){
+    local line
+    local -a cmd
+    _call_program help-command ./manage.py help \
+      |& sed -n '/^ /s/[(), ]/ /gp' \
+      | while read -A line; do cmd=($line $cmd) done
+    _describe -t managepy-command 'manage.py command' cmd
+}
+
+_managepy-inspectdb(){
+  _arguments -s : \
+    $nul_args && ret=0
+}
+
+_managepy-loaddata(){
+  _arguments -s : \
+    '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+    '*::file:_files' \
+    $nul_args && ret=0
+}
+
+_managepy-reset(){
+  _arguments -s : \
+    '--noinput[tells Django to NOT prompt the user for input of any kind.]' \
+    '*::appname:_applist' \
+    $nul_args && ret=0
+}
+
+_managepy-runfcgi(){
+  local state
+  
+  local fcgi_opts
+  fcgi_opts=(
+    'protocol[fcgi, scgi, ajp, ... (default fcgi)]:protocol:(fcgi scgi ajp)'
+    'host[hostname to listen on..]:'
+    'port[port to listen on.]:'
+    'socket[UNIX socket to listen on.]::file:_files'
+    'method[prefork or threaded (default prefork)]:method:(prefork threaded)'
+    'maxrequests[number of requests a child handles before it is killed and a new child is forked (0 = no limit).]:'
+    'maxspare[max number of spare processes / threads.]:'
+    'minspare[min number of spare processes / threads.]:'
+    'maxchildren[hard limit number of processes / threads.]:'
+    'daemonize[whether to detach from terminal.]:boolean:(False True)'
+    'pidfile[write the spawned process-id to this file.]:file:_files'
+    'workdir[change to this directory when daemonizing.]:directory:_files'
+    'outlog[write stdout to this file.]:file:_files'
+    'errlog[write stderr to this file.]:file:_files'
+  )
+  
+  _arguments -s : \
+    $nul_args \
+    '*: :_values "FCGI Setting" $fcgi_opts' && ret=0
+}
+
+_managepy-runserver(){
+  _arguments -s : \
+    '--noreload[tells Django to NOT use the auto-reloader.]' \
+    '--adminmedia[specifies the directory from which to serve admin media.]:directory:_files' \
+    $nul_args && ret=0
+}
+
+_managepy-shell(){
+  _arguments -s : \
+    '--plain[tells Django to use plain Python, not IPython.]' \
+    $nul_args && ret=0
+}
+
+_managepy-sql(){}
+_managepy-sqlall(){}
+_managepy-sqlclear(){}
+_managepy-sqlcustom(){}
+_managepy-sqlflush(){}
+_managepy-sqlindexes(){}
+_managepy-sqlinitialdata(){}
+_managepy-sqlreset(){}
+_managepy-sqlsequencereset(){}
+_managepy-startapp(){}
+
+_managepy-syncdb() {
+  _arguments -s : \
+    '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+    '--noinput[tells Django to NOT prompt the user for input of any kind.]' \
+    $nul_args && ret=0
+}
+
+_managepy-test() {
+  _arguments -s : \
+    '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+    '--noinput[tells Django to NOT prompt the user for input of any kind.]' \
+    '*::appname:_applist' \
+    $nul_args && ret=0
+}
+
+_managepy-testserver() {
+  _arguments -s : \
+    '--verbosity=-[verbosity level; 0=minimal output, 1=normal output, 2=all output.]:Verbosity:((0\:minimal 1\:normal 2\:all))' \
+    '--addrport=-[port number or ipaddr:port to run the server on.]' \
+    '*::fixture:_files' \
+    $nul_args && ret=0
+}
+
+_managepy-validate() {
+  _arguments -s : \
+    $nul_args && ret=0
+}
+
+_managepy-commands() {
+  local -a commands
+  
+  commands=(
+    'adminindex:prints the admin-index template snippet for the given app name(s).'
+    'createcachetable:creates the table needed to use the SQL cache backend.'
+    'dbshell:runs the command-line client for the current DATABASE_ENGINE.'
+    "diffsettings:displays differences between the current settings.py and Django's default settings."
+    'dumpdata:Output the contents of the database as a fixture of the given format.'
+    'flush:Executes ``sqlflush`` on the current database.'
+    'help:manage.py help.'
+    'inspectdb:Introspects the database tables in the given database and outputs a Django model module.'
+    'loaddata:Installs the named fixture(s) in the database.'
+    'reset:Executes ``sqlreset`` for the given app(s) in the current database.'
+    'runfcgi:Run this project as a fastcgi (or some other protocol supported by flup) application,'
+    'runserver:Starts a lightweight Web server for development.'
+    'shell:Runs a Python interactive interpreter.'
+    'sql:Prints the CREATE TABLE SQL statements for the given app name(s).'
+    'sqlall:Prints the CREATE TABLE, custom SQL and CREATE INDEX SQL statements for the given model module name(s).'
+    'sqlclear:Prints the DROP TABLE SQL statements for the given app name(s).'
+    'sqlcustom:Prints the custom table modifying SQL statements for the given app name(s).'
+    'sqlflush:Returns a list of the SQL statements required to return all tables in the database to the state they were in just after they were installed.'
+    'sqlindexes:Prints the CREATE INDEX SQL statements for the given model module name(s).'
+    "sqlinitialdata:RENAMED: see 'sqlcustom'"
+    'sqlreset:Prints the DROP TABLE SQL, then the CREATE TABLE SQL, for the given app name(s).'
+    'sqlsequencereset:Prints the SQL statements for resetting sequences for the given app name(s).'
+    "startapp:Creates a Django app directory structure for the given app name in this project's directory."
+    "syncdb:Create the database tables for all apps in INSTALLED_APPS whose tables haven't already been created."
+    'test:Runs the test suite for the specified applications, or the entire site if no apps are specified.'
+    'testserver:Runs a development server with data from the given fixture(s).'
+    'validate:Validates all installed models.'
+  )
+  
+  _describe -t commands 'manage.py command' commands && ret=0
+}
+
+_applist() {
+  local line
+  local -a apps
+  _call_program help-command "python -c \"import os.path as op, re, django.conf, sys;\\
+                                          bn=op.basename(op.abspath(op.curdir));[sys\\
+                                          .stdout.write(str(re.sub(r'^%s\.(.*?)$' %
+                                          bn, r'\1', i)) + '\n') for i in django.conf.settings.\\
+                                          INSTALLED_APPS if re.match(r'^%s' % bn, i)]\"" \
+                             | while read -A line; do apps=($line $apps) done
+  _values 'Application' $apps && ret=0
+}
+
+_managepy() {
+  local curcontext=$curcontext ret=1
+  
+  if ((CURRENT == 2)); then
+    _managepy-commands
+  else
+    shift words
+    (( CURRENT -- ))
+    curcontext="${curcontext%:*:*}:managepy-$words[1]:"
+    _call_function ret _managepy-$words[1]
+  fi
+}
+
+compdef _managepy manage.py
+compdef _managepy django

+ 174 - 0
plugins/knife/_knife

@@ -0,0 +1,174 @@
+#compdef knife
+
+# These flags should be available everywhere according to man knife
+knife_general_flags=( --help --server-url --key --config --editor --format --log_level --logfile --no-editor --user --print-after --version --yes )
+
+# knife has a very special syntax, some example calls are:
+# knife status
+# knife cookbook list
+# knife role show ROLENAME
+# knife data bag show DATABAGNAME
+# knife role show ROLENAME --attribute ATTRIBUTENAME
+# knife cookbook show COOKBOOKNAME COOKBOOKVERSION recipes
+
+# The -Q switch in compadd allow for completions of things like "data bag" without having to go through two rounds of completion and avoids zsh inserting a \ for escaping spaces
+_knife() {
+  local curcontext="$curcontext" state line
+  typeset -A opt_args
+  cloudproviders=(bluebox ec2 rackspace slicehost terremark)
+  _arguments \
+    '1: :->knifecmd'\
+    '2: :->knifesubcmd'\
+    '3: :->knifesubcmd2' \
+    '4: :->knifesubcmd3' \
+    '5: :->knifesubcmd4' \
+    '6: :->knifesubcmd5'
+  
+  case $state in
+  knifecmd)
+    compadd -Q "$@" bootstrap client configure cookbook "cookbook site" "data bag" exec index node recipe role search ssh status windows $cloudproviders
+  ;;
+  knifesubcmd)
+    case $words[2] in
+    (bluebox|ec2|rackspace|slicehost|terremark)
+      compadd "$@" server images
+    ;;
+    client)
+      compadd -Q "$@" "bulk delete" list create show delete edit reregister
+    ;;
+    configure)
+      compadd "$@" client
+    ;;
+    cookbook)
+      compadd -Q "$@" test list create download delete "metadata from" show "bulk delete" metadata upload
+    ;;
+    node)
+     compadd -Q "$@" "from file" create show edit delete list run_list "bulk delete"
+    ;;
+    recipe)
+     compadd "$@" list
+    ;;
+    role)
+      compadd -Q "$@" "bulk delete" create delete edit "from file" list show
+    ;; 
+    windows)
+      compadd "$@" bootstrap
+    ;;
+    *)
+    _arguments '2:Subsubcommands:($(_knife_options1))'
+    esac
+   ;;
+   knifesubcmd2)
+    case $words[3] in
+     server)
+      compadd "$@" list create delete
+    ;;
+     images)
+      compadd "$@" list
+    ;;
+     site)
+      compadd "$@" vendor show share search download list unshare
+    ;;
+     (show|delete|edit)
+     _arguments '3:Subsubcommands:($(_chef_$words[2]s_remote))'
+    ;;
+    (upload|test)
+     _arguments '3:Subsubcommands:($(_chef_$words[2]s_local) --all)'
+    ;;
+    list)
+     compadd -a "$@" knife_general_flags
+    ;;
+    bag)
+      compadd -Q "$@" show edit list "from file" create delete
+    ;;
+    *)
+      _arguments '3:Subsubcommands:($(_knife_options2))'
+    esac
+   ;;
+   knifesubcmd3)
+     case $words[3] in
+      show)
+       case $words[2] in
+       cookbook)
+          versioncomp=1
+          _arguments '4:Cookbookversions:($(_cookbook_versions) latest)'
+       ;;
+       (node|client|role)
+         compadd "$@" --attribute
+       esac
+     esac
+     case $words[4] in
+     (show|edit)
+     _arguments '4:Subsubsubcommands:($(_chef_$words[2]_$words[3]s_remote))'
+    ;;
+     file)
+     _arguments '*:file or directory:_files -g "*.(rb|json)"'
+    ;;
+      list)
+     compadd -a "$@" knife_general_flags
+    ;;
+        *)
+       _arguments '*:Subsubcommands:($(_knife_options3))'
+    esac
+    ;;
+    knifesubcmd4)
+      if (( versioncomp > 0 )); then
+        compadd "$@" attributes definitions files libraries providers recipes resources templates
+      else
+       _arguments '*:Subsubcommands:($(_knife_options2))'
+      fi
+    ;; 
+    knifesubcmd5) 
+      _arguments '*:Subsubcommands:($(_knife_options3))'
+   esac
+}
+
+# Helper functions to provide the argument completion for several depths of commands
+_knife_options1() {
+ ( for line in $( knife $words[2] --help | grep -v "^knife" ); do echo $line | grep "\-\-"; done )
+}
+
+_knife_options2() {
+ ( for line in $( knife $words[2] $words[3] --help | grep -v "^knife" ); do echo $line | grep "\-\-"; done )
+}
+
+_knife_options3() {
+ ( for line in $( knife $words[2] $words[3] $words[4] --help | grep -v "^knife" ); do echo $line | grep "\-\-"; done )
+}
+
+# The chef_x_remote functions use knife to get a list of objects of type x on the server
+_chef_roles_remote() {
+ (knife role list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_clients_remote() {
+ (knife client list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_nodes_remote() {
+ (knife node list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_cookbooks_remote() {
+ (knife cookbook list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_sitecookbooks_remote() {
+ (knife cookbook site list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+_chef_data_bags_remote() {
+ (knife data bag list | grep \" | awk '{print $1}' | awk -F"," '{print $1}' | awk -F"\"" '{print $2}')
+}
+
+# The chef_x_local functions use the knife config to find the paths of relevant objects x to be uploaded to the server
+_chef_cookbooks_local() {
+ (for i in $( grep cookbook_path $HOME/.chef/knife.rb | awk 'BEGIN {FS = "[" }; {print $2}' | sed 's/\,//g' | sed "s/'//g" | sed 's/\(.*\)]/\1/' ); do ls $i; done)
+}
+
+# This function extracts the available cookbook versions on the chef server
+_cookbook_versions() {
+  (knife cookbook show $words[4] | grep -v $words[4] | grep -v -E '\]|\[|\{|\}' | sed 's/ //g' | sed 's/"//g')
+}
+
+_knife "$@"

+ 0 - 11
plugins/rails3/rails3.plugin.zsh

@@ -1,13 +1,5 @@
 # Rails 3 aliases, backwards-compatible with Rails 2.
 # Rails 3 aliases, backwards-compatible with Rails 2.
 
 
-function _bundle_command {
-  if command -v bundle && [ -e "Gemfile" ]; then
-    bundle exec $@
-  else
-    $@
-  fi
-}
-
 function _rails_command () {
 function _rails_command () {
   if [ -e "script/server" ]; then
   if [ -e "script/server" ]; then
     ruby script/$@
     ruby script/$@
@@ -25,6 +17,3 @@ alias rp='_rails_command plugin'
 alias rs='_rails_command server'
 alias rs='_rails_command server'
 alias rsd='_rails_command server --debugger'
 alias rsd='_rails_command server --debugger'
 alias devlog='tail -f log/development.log'
 alias devlog='tail -f log/development.log'
-
-alias rspec='_bundle_command rspec'
-alias cuke='_bundle_command cucumber'

+ 1 - 1
plugins/redis-cli/_redis-cli

@@ -51,7 +51,7 @@ _1st_arguments=(
   'keys:find all keys matching the given pattern'
   'keys:find all keys matching the given pattern'
   'lastsave:get the UNIX timestamp of the last successful save to disk'
   'lastsave:get the UNIX timestamp of the last successful save to disk'
   'lindex:get an element from a list by its index'
   'lindex:get an element from a list by its index'
-  'linset:insert an element before or after another element in a list'
+  'linsert:insert an element before or after another element in a list'
   'llen:get the length of a list'
   'llen:get the length of a list'
   'lpop:remove and get the first element in a list'
   'lpop:remove and get the first element in a list'
   'lpush:prepend a value to a list'
   'lpush:prepend a value to a list'

+ 52 - 13
plugins/ssh-agent/ssh-agent.plugin.zsh

@@ -1,23 +1,62 @@
-# Based on code from Joseph M. Reagle
-# http://www.cygwin.com/ml/cygwin/2001-06/msg00537.html
+#
+# INSTRUCTIONS
+#
+#   To enabled agent forwarding support add the following to
+#   your .zshrc file:
+#
+#     zstyle :omz:plugins:ssh-agent agent-forwarding on
+#
+#   To load multiple identies use the identities style, For
+#   example:
+#
+#     zstyle :omz:plugins:ssh-agent id_rsa id_rsa2 id_github
+#
+#
+# CREDITS
+#
+#   Based on code from Joseph M. Reagle
+#   http://www.cygwin.com/ml/cygwin/2001-06/msg00537.html
+#
+#   Agent forwarding support based on ideas from
+#   Florent Thoumie and Jonas Pfenniger
+#
 
 
-local SSH_ENV=$HOME/.ssh/environment-$HOST
+local _plugin__ssh_env=$HOME/.ssh/environment-$HOST
+local _plugin__forwarding
 
 
-function start_agent {
-  /usr/bin/env ssh-agent | sed 's/^echo/#echo/' > ${SSH_ENV}
-  chmod 600 ${SSH_ENV}
-  . ${SSH_ENV} > /dev/null
-  /usr/bin/ssh-add;
+function _plugin__start_agent()
+{
+  local -a identities
+
+  # start ssh-agent and setup environment
+  /usr/bin/env ssh-agent | sed 's/^echo/#echo/' > ${_plugin__ssh_env}
+  chmod 600 ${_plugin__ssh_env}
+  . ${_plugin__ssh_env} > /dev/null
+
+  # load identies
+  zstyle -a :omz:plugins:ssh-agent identities identities 
+  echo starting...
+  /usr/bin/ssh-add $HOME/.ssh/${^identities}
 }
 }
 
 
-# Source SSH settings, if applicable
+# test if agent-forwarding is enabled
+zstyle -b :omz:plugins:ssh-agent agent-forwarding _plugin__forwarding
+if [[ ${_plugin__forwarding} == "yes" && -n "$SSH_AUTH_SOCK" ]]; then
+  # Add a nifty symlink for screen/tmux if agent forwarding
+  [[ -L $SSH_AUTH_SOCK ]] || ln -sf "$SSH_AUTH_SOCK" /tmp/ssh-agent-$USER-screen
 
 
-if [ -f "${SSH_ENV}" ]; then
-  . ${SSH_ENV} > /dev/null
+elif [ -f "${_plugin__ssh_env}" ]; then
+  # Source SSH settings, if applicable
+  . ${_plugin__ssh_env} > /dev/null
   ps -ef | grep ${SSH_AGENT_PID} | grep ssh-agent$ > /dev/null || {
   ps -ef | grep ${SSH_AGENT_PID} | grep ssh-agent$ > /dev/null || {
-    start_agent;
+    _plugin__start_agent;
   }
   }
 else
 else
-  start_agent;
+  _plugin__start_agent;
 fi
 fi
 
 
+# tidy up after ourselves
+unfunction _plugin__start_agent
+unset _plugin__forwarding
+unset _plugin__ssh_env
+

+ 280 - 0
plugins/taskwarrior/_task

@@ -0,0 +1,280 @@
+#compdef task
+#
+# zsh completion for taskwarrior
+#
+# Copyright 2010 - 2011 Johannes Schlatow
+# Copyright 2009 P.C. Shyamshankar
+# All rights reserved.
+#
+# This script is part of the taskwarrior project.
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation; either version 2 of the License, or (at your option) any later
+# version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the
+#
+#     Free Software Foundation, Inc.,
+#     51 Franklin Street, Fifth Floor,
+#     Boston, MA
+#     02110-1301
+#     USA
+#
+typeset -g _task_cmds _task_projects _task_tags _task_config _task_modifiers
+_task_projects=($(task _projects))
+_task_tags=($(task _tags))
+_task_ids=($(task _ids))
+_task_config=($(task _config))
+_task_modifiers=(
+	'before' \
+	'after' \
+	'none' \
+	'any' \
+	'is' \
+	'isnt' \
+	'has' \
+	'hasnt' \
+	'startswith' \
+	'endswith' \
+	'word' \
+	'noword'
+)
+_task_cmds=($(task _commands))
+_task_zshcmds=( ${(f)"$(task _zshcommands)"} )
+
+
+_task_idCmds=(
+	'append' \
+	'prepend' \
+	'annotate' \
+	'denotate' \
+	'edit' \
+	'duplicate' \
+	'info' \
+	'start' \
+	'stop' \
+	'done'
+)
+
+_task_idCmdsDesc=(
+	'append:Appends more description to an existing task.' \
+	'prepend:Prepends more description to an existing task.' \
+	'annotate:Adds an annotation to an existing task.' \
+	'denotate:Deletes an annotation of an existing task.' \
+	'edit:Launches an editor to let you modify a task directly.' \
+	'duplicate:Duplicates the specified task, and allows modifications.' \
+	'info:Shows all data, metadata for specified task.' \
+	'start:Marks specified task as started.' \
+	'stop:Removes the start time from a task.' \
+	'done:Marks the specified task as completed.'
+)
+
+_task() {
+    _arguments -s -S \
+        "*::task command:_task_commands"
+    return 0
+}
+
+local -a reply args word
+word=$'[^\0]#\0'
+
+# priorities
+local -a task_priorities
+_regex_words values 'task priorities' \
+	'H:High' \
+	'M:Middle' \
+	'L:Low'
+task_priorities=("$reply[@]")
+
+# projects
+local -a task_projects
+task_projects=(
+	/"$word"/
+	":values:task projects:compadd -a _task_projects"
+)
+
+local -a _task_dates
+_regex_words values 'task dates' \
+	'tod*ay:Today' \
+	'yes*terday:Yesterday' \
+	'tom*orrow:Tomorrow' \
+	'sow:Start of week' \
+	'soww:Start of work week' \
+	'socw:Start of calendar week' \
+	'som:Start of month' \
+	'soy:Start of year' \
+	'eow:End of week' \
+	'eoww:End of work week' \
+	'eocw:End of calendar week' \
+	'eom:End of month' \
+	'eoy:End of year' \
+	'mon:Monday' \
+	'tue:Tuesday'\
+	'wed:Wednesday' \
+	'thu:Thursday' \
+	'fri:Friday' \
+	'sat:Saturday' \
+	'sun:Sunday'
+_task_dates=("$reply[@]")
+
+local -a _task_reldates
+_regex_words values 'task reldates' \
+	'hrs:n hours' \
+	'day:n days' \
+	'1st:first' \
+	'2nd:second' \
+	'3rd:third' \
+	'th:4th, 5th, etc.' \
+	'wks:weeks'
+_task_reldates=("$reply[@]")
+
+task_dates=(
+	\( "$_task_dates[@]" \|
+    \( /$'[0-9][0-9]#'/- \( "$_task_reldates[@]" \) \)
+	\)
+)
+
+_regex_words values 'task frequencies' \
+	'daily:Every day' \
+	'day:Every day' \
+	'weekdays:Every day skipping weekend days' \
+	'weekly:Every week' \
+	'biweekly:Every two weeks' \
+	'fortnight:Every two weeks' \
+	'quarterly:Every three months' \
+	'semiannual:Every six months' \
+	'annual:Every year' \
+	'yearly:Every year' \
+	'biannual:Every two years' \
+	'biyearly:Every two years'
+_task_freqs=("$reply[@]")
+
+local -a _task_frequencies
+_regex_words values 'task frequencies' \
+	'd:days' \
+	'w:weeks' \
+	'q:quarters' \
+	'y:years'
+_task_frequencies=("$reply[@]")
+
+task_freqs=(
+	\( "$_task_freqs[@]" \|
+     \( /$'[0-9][0-9]#'/- \( "$_task_frequencies[@]" \) \)
+	\)
+)
+
+# attributes
+local -a task_attributes
+_regex_words -t ':' default 'task attributes' \
+	'pro*ject:Project name:$task_projects' \
+	'du*e:Due date:$task_dates' \
+	'wa*it:Date until task becomes pending:$task_dates' \
+	're*cur:Recurrence frequency:$task_freqs' \
+	'pri*ority:priority:$task_priorities' \
+	'un*til:Recurrence end date:$task_dates' \
+	'fg:Foreground color' \
+	'bg:Background color' \
+	'li*mit:Desired number of rows in report'
+task_attributes=("$reply[@]")
+
+args=(
+	\( "$task_attributes[@]" \|
+	\( /'(project|due|wait|recur|priority|until|fg|bg|limit).'/- \( /$'[^:]#:'/ ":default:modifiers:compadd -S ':' -a _task_modifiers" \) \) \|
+	\( /'(rc).'/- \( /$'[^:]#:'/ ":arguments:config:compadd -S ':' -a _task_config" \) \) \|
+	\( /'(+|-)'/- \( /"$word"/ ":values:remove tag:compadd -a _task_tags" \) \) \|
+	\( /"$word"/ \)
+	\) \#
+)
+_regex_arguments _task_attributes "${args[@]}"
+
+## task commands
+
+# default completion
+(( $+functions[_task_default] )) ||
+_task_default() {
+	_task_attributes "$@"
+}
+
+# commands expecting an ID
+(( $+functions[_task_id] )) ||
+_task_id() {
+	if (( CURRENT < 3 )); then
+		# update IDs
+		_task_zshids=( ${(f)"$(task _zshids)"} )
+		_describe -t values 'task IDs' _task_zshids
+	else
+		_task_attributes "$@"
+	fi
+}
+
+# merge completion
+(( $+functions[_task_merge] )) ||
+_task_merge() {
+	# TODO match URIs in .taskrc
+	_files
+}
+
+# push completion
+(( $+functions[_task_push] )) ||
+_task_push() {
+	# TODO match URIs in .taskrc
+	_files
+}
+
+# pull completion
+(( $+functions[_task_pull] )) ||
+_task_pull() {
+	# TODO match URIs in .taskrc
+	_files
+}
+
+
+# modify (task [0-9]* ...) completion
+(( $+functions[_task_modify] )) ||
+_task_modify() {
+	_describe -t commands 'task command' _task_idCmdsDesc
+	_task_attributes "$@"
+}
+
+## first level completion => task sub-command completion
+(( $+functions[_task_commands] )) ||
+_task_commands() {
+    local cmd ret=1
+	if (( CURRENT == 1 )); then
+		# update IDs
+		_task_zshids=( ${(f)"$(task _zshids)"} )
+
+		_describe -t commands 'task command' _task_zshcmds
+		_describe -t values 'task IDs' _task_zshids
+		# TODO match more than one ID
+	elif [[ $words[1] =~ ^[0-9]*$ ]] then
+		 _call_function ret _task_modify
+		 return ret
+	else
+#        local curcontext="${curcontext}"
+#        cmd="${_task_cmds[(r)$words[1]:*]%%:*}"
+		  cmd="${_task_cmds[(r)$words[1]]}"
+		  idCmd="${(M)_task_idCmds[@]:#$words[1]}"
+        if (( $#cmd )); then
+#            curcontext="${curcontext%:*:*}:task-${cmd}"
+
+				if (( $#idCmd )); then
+					_call_function ret _task_id
+				else
+					_call_function ret _task_${cmd} ||
+						_call_function ret _task_default ||
+							_message "No command remaining."
+				fi
+        else
+            _message "Unknown subcommand ${cmd}"
+        fi
+        return ret
+    fi
+}

+ 21 - 0
plugins/taskwarrior/taskwarrior.plugin.zsh

@@ -0,0 +1,21 @@
+################################################################################
+# Author: Pete Clark
+# Email: pete[dot]clark[at]gmail[dot]com
+# Version: 0.1 (05/24/2011)
+# License: WTFPL<http://sam.zoy.org/wtfpl/>
+#
+# This oh-my-zsh plugin adds smart tab completion for
+# TaskWarrior<http://taskwarrior.org/>. It uses the zsh tab completion
+# script (_task) distributed with TaskWarrior for the completion definitions.
+#
+# Typing task[tabtab] will give you a list of current tasks, task 66[tabtab]
+# gives a list of available modifications for that task, etc.
+################################################################################
+
+zstyle ':completion:*:*:task:*' verbose yes
+zstyle ':completion:*:*:task:*:descriptions' format '%U%B%d%b%u'
+
+zstyle ':completion:*:*:task:*' group-name ''
+
+alias t=task
+compdef _task t=task

+ 20 - 0
themes/blinks.zsh-theme

@@ -0,0 +1,20 @@
+# https://github.com/blinks zsh theme
+
+function _prompt_char() {
+  if $(git rev-parse --is-inside-work-tree >/dev/null 2>&1); then
+    echo "%{%F{blue}%}±%{%f%k%b%}"
+  else
+    echo ' '
+  fi
+}
+
+ZSH_THEME_GIT_PROMPT_PREFIX=" [%{%B%F{blue}%}"
+ZSH_THEME_GIT_PROMPT_SUFFIX="%{%f%k%b%K{black}%B%F{green}%}]"
+ZSH_THEME_GIT_PROMPT_DIRTY=" %{%F{red}%}*%{%f%k%b%}"
+ZSH_THEME_GIT_PROMPT_CLEAN=""
+
+PROMPT='%{%f%k%b%}
+%{%K{black}%B%F{green}%}%n%{%B%F{blue}%}@%{%B%F{cyan}%}%m%{%B%F{green}%} %{%b%F{yellow}%K{black}%}%~%{%B%F{green}%}$(git_prompt_info)%E%{%f%k%b%}
+%{%K{black}%}$(_prompt_char)%{%K{black}%} %#%{%f%k%b%} '
+
+RPROMPT='!%{%B%F{cyan}%}%!%{%f%k%b%}'

文件差异内容过多而无法显示
+ 2 - 2
themes/philips.zsh-theme


+ 96 - 0
themes/sunrise.zsh-theme

@@ -0,0 +1,96 @@
+#-------------------------------------------------------------------------------
+# Sunrise theme for oh-my-zsh by Adam Lindberg (eproxus@gmail.com)
+# Intended to be used with Solarized: http://ethanschoonover.com/solarized
+# (Needs Git plugin for current_branch method)
+#-------------------------------------------------------------------------------
+
+# Color shortcuts
+R=$fg[red]
+G=$fg[green]
+M=$fg[magenta]
+RB=$fg_bold[red]
+YB=$fg_bold[yellow]
+BB=$fg_bold[blue]
+RESET=$reset_color
+
+if [ "$(whoami)" = "root" ]; then
+    PROMPTCOLOR="%{$RB%}" PREFIX="-!-";
+else
+    PROMPTCOLOR="" PREFIX="---";
+fi
+
+local return_code="%(?..%{$R%}%? ↵%{$RESET%})"
+
+# Get the status of the working tree (copied and modified from git.zsh)
+custom_git_prompt_status() {
+  INDEX=$(git status --porcelain 2> /dev/null)
+  STATUS=""
+  # Non-staged
+  if $(echo "$INDEX" | grep '^?? ' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_UNTRACKED$STATUS"
+  fi
+  if $(echo "$INDEX" | grep '^UU ' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_UNMERGED$STATUS"
+  fi
+  if $(echo "$INDEX" | grep '^ D ' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_DELETED$STATUS"
+  fi
+  if $(echo "$INDEX" | grep '^.M ' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_MODIFIED$STATUS"
+  elif $(echo "$INDEX" | grep '^AM ' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_MODIFIED$STATUS"
+  elif $(echo "$INDEX" | grep '^ T ' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_MODIFIED$STATUS"
+  fi
+  # Staged
+  if $(echo "$INDEX" | grep '^D  ' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_STAGED_DELETED$STATUS"
+  fi
+  if $(echo "$INDEX" | grep '^R' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_STAGED_RENAMED$STATUS"
+  fi
+  if $(echo "$INDEX" | grep '^M' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_STAGED_MODIFIED$STATUS"
+  fi
+  if $(echo "$INDEX" | grep '^A' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_PROMPT_STAGED_ADDED$STATUS"
+  fi
+
+  if $(echo -n "$STATUS" | grep '.*' &> /dev/null); then
+    STATUS="$ZSH_THEME_GIT_STATUS_PREFIX$STATUS"
+  fi
+
+  echo $STATUS
+}
+
+# get the name of the branch we are on (copied and modified from git.zsh)
+function custom_git_prompt() {
+  ref=$(git symbolic-ref HEAD 2> /dev/null) || return
+  echo "$ZSH_THEME_GIT_PROMPT_PREFIX${ref#refs/heads/}$(parse_git_dirty)$(git_prompt_ahead)$(custom_git_prompt_status)$ZSH_THEME_GIT_PROMPT_SUFFIX"
+}
+
+# %B sets bold text
+PROMPT='%B$PREFIX %2~ $(custom_git_prompt)%{$M%}%B»%b%{$RESET%} '
+RPS1="${return_code}"
+
+ZSH_THEME_GIT_PROMPT_PREFIX="%{$YB%}‹"
+ZSH_THEME_GIT_PROMPT_SUFFIX="%{$YB%}›%{$RESET%} "
+
+ZSH_THEME_GIT_PROMPT_DIRTY="%{$R%}*"
+ZSH_THEME_GIT_PROMPT_CLEAN=""
+
+ZSH_THEME_GIT_PROMPT_AHEAD="%{$BB%}➔"
+
+ZSH_THEME_GIT_STATUS_PREFIX=" "
+
+# Staged
+ZSH_THEME_GIT_PROMPT_STAGED_ADDED="%{$G%}A"
+ZSH_THEME_GIT_PROMPT_STAGED_MODIFIED="%{$G%}M"
+ZSH_THEME_GIT_PROMPT_STAGED_RENAMED="%{$G%}R"
+ZSH_THEME_GIT_PROMPT_STAGED_DELETED="%{$G%}D"
+
+# Not-staged
+ZSH_THEME_GIT_PROMPT_UNTRACKED="%{$R%}⁇"
+ZSH_THEME_GIT_PROMPT_MODIFIED="%{$R%}M"
+ZSH_THEME_GIT_PROMPT_DELETED="%{$R%}D"
+ZSH_THEME_GIT_PROMPT_UNMERGED="%{$R%}UU"

+ 1 - 1
tools/upgrade.sh

@@ -9,4 +9,4 @@ echo "\033[0;32m"'\____/_/ /_/  /_/ /_/ /_/\__, /    /___/____/_/ /_/  '"\033[0m
 echo "\033[0;32m"'                        /____/                       '"\033[0m"
 echo "\033[0;32m"'                        /____/                       '"\033[0m"
 echo "\033[0;34mHooray! Oh My Zsh has been updated and/or is at the current version.\033[0m"
 echo "\033[0;34mHooray! Oh My Zsh has been updated and/or is at the current version.\033[0m"
 echo "\033[0;34mTo keep up on the latest, be sure to follow Oh My Zsh on twitter: \033[1mhttp://twitter.com/ohmyzsh\033[0m"
 echo "\033[0;34mTo keep up on the latest, be sure to follow Oh My Zsh on twitter: \033[1mhttp://twitter.com/ohmyzsh\033[0m"
-cd $current_path
+cd "$current_path"